//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Diagnostics;

using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels.Tcp;

namespace CLRUnleashed.Remoting
{
	public class RemotingTest : MarshalByRefObject
	{
		private double DoTest(TimeObject timeService, int iterations)
		{
			string result;
			DateTime start = DateTime.Now;
			for(int i = 0; i < iterations; i++)
			{
				result = timeService.Time;
			}
			DateTime stop = DateTime.Now;
			TimeSpan elapsed = stop - start;
			return ((double)iterations/(double)elapsed.TotalMilliseconds) * 1000.0;
		}
		public double Test(string path, int iterations)
		{
			Debug.WriteLine(string.Format("Test: {0} {1}", path, iterations));
			if (path == null) 
			{
				throw new ArgumentNullException("Null greeting!");
			}
			Debug.WriteLine(string.Format("Using config file - {0}", path));
			RemotingConfiguration.Configure(path);
			TimeObject timeService = new TimeObject();
			double result = 0;
			if (true == RemotingServices.IsTransparentProxy(timeService))
			{
				Debug.WriteLine("Test: TimeObject activated on server");
				result = DoTest(timeService, iterations);
			}
			return result;
		}
	}
}
