//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;
using System.Diagnostics;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;
using System.Runtime.Remoting;
using System.Runtime.Remoting.MetadataServices;

namespace WeatherProg
{
	/// <summary>
	/// Summary description for WeatherForm.
	/// </summary>
	public class WeatherForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox url;
		private System.Windows.Forms.Button initializeButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public WeatherForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.url = new System.Windows.Forms.TextBox();
			this.initializeButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// url
			// 
			this.url.Location = new System.Drawing.Point(8, 56);
			this.url.Name = "url";
			this.url.ReadOnly = true;
			this.url.Size = new System.Drawing.Size(312, 20);
			this.url.TabIndex = 0;
			this.url.Text = "http://www.vbws.com/services/weatherretriever.asmx?WSDL";
			// 
			// initializeButton
			// 
			this.initializeButton.Location = new System.Drawing.Point(8, 16);
			this.initializeButton.Name = "initializeButton";
			this.initializeButton.TabIndex = 1;
			this.initializeButton.Text = "Initialize";
			this.initializeButton.Click += new System.EventHandler(this.OnInitialize);
			// 
			// WeatherForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.initializeButton,
																		  this.url});
			this.Name = "WeatherForm";
			this.Text = "Weather";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WeatherForm());
		}

		private void SoapSuds(object s)
		{
			string path = (string)s;
			string assemblyFile = "weather.dll";

			try
			{
				MemoryStream ms = new MemoryStream();
				MetaData.RetrieveSchemaFromUrlToStream(path, ms);
				ms.Seek(0, SeekOrigin.Begin);
				ArrayList sa = new ArrayList();
				MetaData.ConvertSchemaStreamToCodeSourceStream(false, ".", ms, sa, null, "CLRUnleashed.Weather");
				MetaData.ConvertCodeSourceStreamToAssemblyFile(sa, assemblyFile, "");
				ms.Close();

				Assembly a = Assembly.LoadFrom(assemblyFile);
				Type t = a.GetType("CLRUnleashed.Weather.WeatherRetrieverSoap");
				MethodInfo m = t.GetMethod("GetTemperature",
					                       BindingFlags.Public | BindingFlags.Instance
					                       );
				ParameterInfo [] p = m.GetParameters();
				object o = Activator.CreateInstance(t);
				object result = m.Invoke(o, new object [] {"53717"});
				float temperature = (float)result;
			}
			catch(Exception e)
			{
				Debug.WriteLine(e);
			}
		}
		private void OnInitialize(object sender, System.EventArgs e)
		{
			try
			{
				ThreadPool.QueueUserWorkItem(new WaitCallback(SoapSuds), url.Text);
				// SoapSuds(url.Text);
			}
			catch(Exception exception)
			{
				Debug.WriteLine(exception);
			}
		}
	}
}
